#include <vector>
#include <algorithm>
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_ttf.h>

int SDL_main(int, char**)
{
	//inicializace SDL - pouze video
	SDL_Init(SDL_INIT_VIDEO);
	IMG_Init(IMG_INIT_PNG);
	TTF_Init();
	//vytvoen okna
	SDL_Window* MainWindow = SDL_CreateWindow("8 bitova grafika", //jmno okna
		SDL_WINDOWPOS_CENTERED, //okno bude vytvoeno ve stedu obrazovky
		SDL_WINDOWPOS_CENTERED,
		800, 600, NULL); //ka, vka a flagy okna (ty nepotebujeme)


	//vytvoen rendereru
	SDL_Renderer* renderer = SDL_CreateRenderer(MainWindow, -1, SDL_RENDERER_TARGETTEXTURE);
	//vytvoen 8 bitov surface
	SDL_Surface* MySurface = SDL_CreateRGBSurface(NULL, 256, 100, 8, 0, 0, 0, 0);
	//aktivace prhlednosti
	SDL_SetSurfaceBlendMode(MySurface,SDL_BLENDMODE_BLEND);

	//vytvoen palety barev a naplnn ji hodnotami
	SDL_Color color[256];
	for (int a = 0; a < 256; a++)
	{
		color[a].r = a;
		color[a].g = color[a].b = 0;
		color[a].a = a;
	}
	//aktivace na palety barev 
	SDL_SetPaletteColors(MySurface->format->palette, color, 0, 256);

	//vykreslen pechodu
	for (int a = 0; a < 256; a++)
	{
		for (int b = 0; b < 100; b++)
		{
			Uint8* BeginOfArray = (Uint8*)MySurface->pixels;
			int IndexOfRow = b*MySurface->pitch;
			int IndexOfColumn = a*MySurface->format->BytesPerPixel;
			*(BeginOfArray + IndexOfRow + IndexOfColumn) = a;
		}
	}

	//vytvoen textury
	SDL_Texture* FinalTexture = SDL_CreateTextureFromSurface(renderer, MySurface);

	//nastaven TargetRect tak, aby ml stejnou velikost jako textura
	//bude pouit pro vykreslen na obrazovku
	SDL_Rect* TargetRect = new SDL_Rect;
	TargetRect->y = TargetRect->x = 0;
	TargetRect->h = 100 * 2;
	TargetRect->w = 256 * 2;





	bool End = false;								//promnn, kter d hlavn smyku
	SDL_Event* event = new SDL_Event;				//struktura, kter uchovv udlosti
	while (!End)									//zatek hlavn smyky
	{
		while (SDL_PollEvent(event))				//naten udlosti z fronty
		{
			if (event->type == SDL_QUIT)				//manipulace s udlost
				End = true;							//ukonen aplikace
			else if (event->type == SDL_KEYDOWN)		//reagovn na stisk klvesy
			{
				switch (event->key.keysym.sym)
				{
				case SDLK_RIGHT:					//ipka v pravo -> upraven x-ov pozice obdelnku
					TargetRect->x += 5; break;
				case SDLK_LEFT:						//ipka v levo -> upraven x-ov pozice obdelnku
					TargetRect->x -= 5; break;
				case SDLK_UP:						//ipka nahoru -> upraven y-ov pozice obdelnku
					TargetRect->y -= 5; break;
				case SDLK_DOWN:						//ipka dol -> upraven y-ov pozice obdelnku
					TargetRect->y += 5; break;
				}
			}
		}

		SDL_SetRenderDrawColor(renderer, 0, 0, 255, 255);		//nastaven barvy, kterou se bude vykreslovat pozad
		SDL_RenderClear(renderer);								//vykreslen pozad

		//vykreslen pechodu
		SDL_RenderCopy(renderer, FinalTexture, NULL, TargetRect);

		SDL_RenderPresent(renderer);



	}

	//nen poteba mazat jednotliv objekty, po ukonen programu voln msto automaticky promae OS

	TTF_Quit();								//ukonen SDL_ttf
	IMG_Quit();								//ukonen SDL_Image
	SDL_Quit();								//Ukonen SDL
	return 0;
}